package org.jeecg.modules.stm.my.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.my.entity.MyTask;
import org.jeecg.modules.stm.my.service.IMyTaskService;
import org.jeecg.modules.stm.utils.UserUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;

/**
 * @Description: 待办任务
 * @Author: jeecg-boot
 * @Date:   2024-04-17
 * @Version: V1.0
 */
@RestController
@RequestMapping("/my/myTask")
@Slf4j
public class MyTaskController extends JeecgController<MyTask, IMyTaskService> {
	@Autowired
	private IMyTaskService myTaskService;
	
	/**
	 * 分页列表查询
	 *
	 * @param myTask
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "待办任务-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<MyTask>> queryPageList(MyTask myTask,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<MyTask> queryWrapper = QueryGenerator.initQueryWrapper(myTask, req.getParameterMap());
		queryWrapper.eq("uid", UserUtil.getUserId());
		Page<MyTask> page = new Page<MyTask>(pageNo, pageSize);
		IPage<MyTask> pageList = myTaskService.page(page, queryWrapper);

		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param myTask
	 * @return
	 */
	@AutoLog(value = "待办任务-添加")
	  
	@RequiresPermissions("my:my_task:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody MyTask myTask) {
		myTaskService.save(myTask);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param myTask
	 * @return
	 */
	@AutoLog(value = "待办任务-编辑")
	  
	@RequiresPermissions("my:my_task:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody MyTask myTask) {
		myTaskService.updateById(myTask);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "待办任务-通过id删除")
	  
	@RequiresPermissions("my:my_task:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		myTaskService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "待办任务-批量删除")
	  
	@RequiresPermissions("my:my_task:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.myTaskService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "待办任务-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<MyTask> queryById(@RequestParam(name="id",required=true) String id) {
		MyTask myTask = myTaskService.getById(id);
		if(myTask==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(myTask);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param myTask
    */
    @RequiresPermissions("my:my_task:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, MyTask myTask) {
        return super.exportXls(request, myTask, MyTask.class, "待办任务");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("my:my_task:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, MyTask.class);
    }

}
